{$FORM TForm2, Unit2.sfm}                                       

uses
  Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, s_utils;

var chips, k_el, start_amount, wish_amount, amount, yesno, spin_count, fl_stop, was_betting, sim_mode, stop_loss, tr_stop_loss, amount_after_all_bets;
var elements, last_nr, _file, fName, fName_numbers, elements_played;

procedure add_to_file(su_text_, su_type_, su_fName);
var su_file;
var x:TForm;
begin                              
  if su_type_=-2 then begin
    {here the files are created and will be saved in disc C:, you can change this
    the file with all info will be c:\2009-07-22_14-37-59_all.txt - the name of file will contain the start date and time
    the file with all landed numbers will be c:\2009-07-22_14-37-59_nr.txt - the name of file will contain the start date and time
    in case you want to save to other directory, example directory ScriptResult on disc D;
    just write fName:='d:\ScriptResults\'+FormatDateTime('yyyy-mm-dd_hh-nn-ss',now);}
    AssignFile(su_file,su_fName+'_all.txt'); Rewrite(su_file); CloseFile(su_file);
    AssignFile(su_file,su_fName+'_nr.txt');  Rewrite(su_file); CloseFile(su_file);
  end;
  if su_type_=0 then begin //here we will write all info to a file
    Memo1.Lines.Add(su_text_);
    AssignFile(su_file,su_fName+'_all.txt'); Append(su_file);
    WriteLn(su_file,su_text_); //here we will write all info to a file
    CloseFile(su_file);
  end;
  if su_type_=-1 then begin // here we will write all landed numbers to a file
    AssignFile(su_file,su_fName+'_nr.txt'); Append(su_file);
    WriteLn(su_file,su_text_);
    CloseFile(su_file);
  end;
end;

procedure add_to_lastY;
//add last landed number to the set of last Y landed numbers
begin
 if last_nr<>0 then begin
   if number_is(last_nr,'R') then elements[0,4]:=copy(elements[0,4],2,elements[0,5]-1)+'R'
                             else elements[0,4]:=copy(elements[0,4],2,elements[0,5]-1)+'B';
 end else elements[0,4]:=copy(elements[0,4],2,elements[0,5]-1)+'0';
end;

function landed_is:string
begin
 result:='';
 if last_nr<>0 then begin
   if number_is(last_nr,'R') then result:='R' else result:='B';
 end else result:='0';
end;

procedure reset_system(sysK);
//reset setting for the system K in case we meet the 0 when wait the last sequence
begin
 if (elements[sysK,2]=0) or ((elements[sysK,2]>0)and(elements[0,6]=1)) then begin  //if we (haven't bet) or (we have bet and need to reset)
   elements[sysK,2]:=0; //cnt_progression became 0
   elements[sysK,14]:=0; //reset the need to bet
   elements[sysK,0]:=0; //counter is again 0
   if elements[sysK,2]=0 then add_to_file('Spin count - '+IntToStr(spin_count)+'. '+elements[sysK,13]+'. We have ZERO before <right> colour to bet. The system (without placed bets) will restart.',0,fName)
                         else add_to_file('Spin count - '+IntToStr(spin_count)+'. '+elements[sysK,13]+'. We have ZERO before <right> colour to bet. The system (with placed bets) will restart.',0,fName);
   if (elements[sysK,10]=2)or(elements[sysK,10]=4) then begin
     elements[sysK,15,0]:=0; elements[sysK,15,1]:=0;//we reset sequence with B and with R
   end;
 end;
end;

procedure stack_array;
 var k, k1, str1, tag_, str2, k2;
begin
 add_to_lastY;
 for k:=1 to VarArrayHighBound(elements,1) do begin//here we go through the all elements
   if elements[k,7]=0 then continue;//in case play_cnt=0 we ignore this element
   if elements[k,14]=0 then begin//we still wait for good sequences
     if elements[k,10]=1 then begin
       str1:=''; for k1:=1 to elements[k,9] do str1:=str1+elements[k,11];//we create the wished sequence
       if elements[k,0]<elements[k,1] then begin//if we wait the firsts x.1 sequences
         str2:=copy(elements[0,4],elements[0,5]-elements[k,9]-1,elements[k,9]+2);//get last elements[k,9]+2
         if (copy(str2,1,1)<>elements[k,11]) and (copy(str2,2,elements[k,9])=str1) and (copy(str2,length(str2),1)<>elements[k,11])  //good xRRx xRRRx
           then elements[k,0]:=elements[k,0]+1; //we increase the count
         if copy(elements[0,4],elements[0,5]-elements[k,9],elements[k,9]+1)=str1+elements[k,11] //bad - we have more R than need
           then elements[k,0]:=0; //we reset the count
       end else begin//this mean that we only wait the last sequence - and next we will bet
         if last_nr<>0 then begin//next we wait the last sequence
           if copy(elements[0,4],elements[0,5]-elements[k,9]+1,elements[k,9])=str1 then begin//we meet the last sequence
             elements[k,0]:=elements[k,0]+1; //we increase the count
             elements[k,14]:=1;//next we bet
             if elements[k,11]='R' then elements[k,4]:='R' else elements[k,4]:='B';//we set that we bet on the opposite
           end;
         end else reset_system(k); //If here landed 0 we reset
       end;
     end;//if elements[k,10]=1 then begin
     if elements[k,10]=2 then begin
       str1:=['','']; for k1:=1 to elements[k,9] do begin str1[0]:=str1[0]+'R'; str1[1]:=str1[1]+'B'; end;//we create the wished sequence
       if elements[k,0]<elements[k,1] then begin//if we wait the firsts x.1 sequences
         str2:=copy(elements[0,4],elements[0,5]-elements[k,9]-1,elements[k,9]+2);//get last elements[k,9]+2
         if (copy(str2,1,1)<>'R') and (copy(str2,2,elements[k,9])=str1[0]) and (copy(str2,length(str2),1)<>'R')  //good xRRx xRRRx
           then begin
             elements[k,0]:=elements[k,0]+1; //we increase the count
             elements[k,15,0]:=1; //we set that sequence with R we already have
         end;
         if (copy(str2,1,1)<>'B') and (copy(str2,2,elements[k,9])=str1[1]) and (copy(str2,length(str2),1)<>'B')  //good xRRx xRRRx
           then begin
             elements[k,0]:=elements[k,0]+1; //we increase the count
             elements[k,15,1]:=1; //we set that sequence with B we already have
         end;
         if (copy(elements[0,4],elements[0,5]-elements[k,9],elements[k,9]+1)=str1[0]+'R') //bad - we have more R than need
          or(copy(elements[0,4],elements[0,5]-elements[k,9],elements[k,9]+1)=str1[1]+'B')
           then begin
             elements[k,0]:=0; //we reset the count
             elements[k,15,0]:=0; elements[k,15,1]:=0;//we reset sequence with B and with R
         end;
         if (elements[k,0]=elements[k,1]) and ((elements[k,15,0]=0)or(elements[k,15,1]=0)) then //we need at still one good sequence to be in different colour then the all other good sequences
           elements[k,0]:=elements[k,0]-1; //we decrease the count
       end else begin//this mean that we only wait the last sequence - and next we will bet
         if last_nr<>0 then begin//next we wait the last sequence
           if (copy(elements[0,4],elements[0,5]-elements[k,9]+1,elements[k,9])=str1[0])or
              (copy(elements[0,4],elements[0,5]-elements[k,9]+1,elements[k,9])=str1[1]) then begin//we meet the last sequence
             elements[k,0]:=elements[k,0]+1; //we increase the count
             elements[k,14]:=1;//next we bet
             if copy(elements[0,4],elements[0,5],1)='R' then elements[k,4]:='R' else elements[k,4]:='B';//we set that we bet on the opposite
           end;
         end else reset_system(k); //If here landed 0 we reset
       end;
     end;//if elements[k,10]=2 then begin
     if elements[k,10]=3 then begin
       str1:=''; for k1:=1 to elements[k,9] do str1:=str1+elements[k,11];//we create the wshed sequence
       if elements[k,0]<elements[k,1] then begin//if we wait the firsts x.1 sequences
         if (copy(elements[0,4],elements[0,5]-elements[k,9]+1,elements[k,9])=str1) //good RRR+ - if we have the sequence and it is not continued
            and (copy(elements[0,4],elements[0,5]-elements[k,9],1)<>elements[k,11]) then elements[k,0]:=elements[k,0]+1; //we increase the count
         tag_:=0;
         for k1:=elements[k,9]+1 downto 3 do begin  //bad - searh to not be xRx xRRx xRRRx xRRRRx ....
           str2:=copy(elements[0,4],elements[0,5]-k1+1,k1);
           if (copy(str2,1,1)<>elements[k,11]) and (copy(str1,1,length(str2)-2)=copy(str2,2,length(str2)-2)) and
              (copy(str2,length(str2),1)<>elements[k,11]) then tag_:=1;
         end;
         if tag_=1 then elements[k,0]:=0; //we reset the count
       end else begin//this mean that we only wait the last sequence - and next we will bet
         if last_nr<>0 then begin//next we wait the last sequence
           if (copy(elements[0,4],elements[0,5]-elements[k,9]+2,elements[k,9]-1)=copy(str1,1,length(str1)-1))  //we meet the last sequence xRR
           and (copy(elements[0,4],elements[0,5]-elements[k,9]+1,1)<>elements[k,11]) then begin  //and it is not continued from previous one
             elements[k,0]:=elements[k,0]+1; //we increase the count
             elements[k,14]:=1;//next we bet
             if elements[k,11]='R' then elements[k,4]:='B' else elements[k,4]:='R';//we set that we bet on the opposite
           end;
         end else reset_system(k); //If here landed 0 we reset
       end;
     end;//if elements[k,10]=3 then begin
     if elements[k,10]=4 then begin
       str1:=['','']; for k1:=1 to elements[k,9] do begin str1[0]:=str1[0]+'R'; str1[1]:=str1[1]+'B'; end;//we create the wished sequence
       if elements[k,0]<elements[k,1] then begin//if we wait the firsts x.1 sequences
         if (copy(elements[0,4],elements[0,5]-elements[k,9]+1,elements[k,9])=str1[0]) //good RRR+ - if we have the sequence and it is not continued
            and (copy(elements[0,4],elements[0,5]-elements[k,9],1)<>'R') then begin
           elements[k,0]:=elements[k,0]+1; //we increase the count
           elements[k,15,0]:=1; //we set that sequence with R we already have
         end;
         if (copy(elements[0,4],elements[0,5]-elements[k,9]+1,elements[k,9])=str1[1]) //good RRR+ - if we have the sequence and it is not continued
            and (copy(elements[0,4],elements[0,5]-elements[k,9],1)<>'B') then begin
           elements[k,0]:=elements[k,0]+1; //we increase the count
           elements[k,15,1]:=1; //we set that sequence with B we already have
         end;
         tag_:=0;
         for k1:=elements[k,9]+1 downto 3 do begin  //bad - searh to not be xRx xRRx xRRRx xRRRRx ....
           str2:=copy(elements[0,4],elements[0,5]-k1+1,k1);
           if (copy(str2,1,1)<>'R') and (copy(str1[0],1,length(str2)-2)=copy(str2,2,length(str2)-2)) and
              (copy(str2,length(str2),1)<>'R') then tag_:=1;
           if (copy(str2,1,1)<>'B') and (copy(str1[1],1,length(str2)-2)=copy(str2,2,length(str2)-2)) and
              (copy(str2,length(str2),1)<>'B') then tag_:=1;
         end;
         if tag_=1 then begin
           elements[k,0]:=0; //we reset the count
           elements[k,15,0]:=0; elements[k,15,1]:=0;//we reset sequence with B and with R
         end;
         if (elements[k,0]=elements[k,1]) and ((elements[k,15,0]=0)or(elements[k,15,1]=0)) then //we need at still one good sequence to be in different colour then the all other good sequences
           elements[k,0]:=elements[k,0]-1; //we decrease the count
       end else begin//this mean that we only wait the last sequence - and next we will bet
         if last_nr<>0 then begin//next we wait the last sequence
           if ((copy(elements[0,4],elements[0,5]-elements[k,9]+2,elements[k,9]-1)=copy(str1[0],1,length(str1[0])-1))
                and (copy(elements[0,4],elements[0,5]-elements[k,9]+1,1)<>'R'))
           or ((copy(elements[0,4],elements[0,5]-elements[k,9]+2,elements[k,9]-1)=copy(str1[1],1,length(str1[1])-1))
                and (copy(elements[0,4],elements[0,5]-elements[k,9]+1,1)<>'B'))
           then begin//we meet the last sequence and it is not continued from previous one
             elements[k,0]:=elements[k,0]+1; //we increase the count
             elements[k,14]:=1;//next we bet
             if copy(elements[0,4],elements[0,5],1)='R' then elements[k,4]:='B' else elements[k,4]:='R';//we set that we bet on the opposite
           end;
         end else reset_system(k); //If here landed 0 we reset
       end;
     end;//if elements[k,10]=4 then begin
   end else begin//we have bet
     if number_is(last_nr,elements[k,4]) then begin //if win
       amount:=amount+(elements[k,5,elements[k,2]]*elements[0,0]*(elements[k,3]-(elements[k,6]-1)));//in case the win we increase the amount
       add_to_file('Spin count - '+IntToStr(spin_count)+'. '+elements[k,13]+'. We have bet $'+FormatFloat('0.##',elements[k,5,elements[k,2]]*elements[0,0])+' on '+elements[k,4]+' and win. Progression '+FormatFloat('0.##',elements[k,2])+' of '+IntToStr(VarArrayHighBound(elements[k,5],1)),0,fName);
       if elements[k,7]<>-1 then elements[k,7]:=elements[k,7]-1;//we decrease the play_cnt
       elements[k,2]:=0; elements[k,14]:=0; elements[k,0]:=0; //cnt_progression became 0, reset the need to bet, counter is again 0
     end else begin //if lost
       elements[k,14]:=0; //reset the need to bet
       amount:=amount-(elements[k,5,elements[k,2]]*elements[0,0]*elements[k,6]);//in case the lose we decrese amount with how much we have bet
       add_to_file('Spin count - '+IntToStr(spin_count)+'. '+elements[k,13]+'. We have bet $'+FormatFloat('0.##',elements[k,5,elements[k,2]]*elements[0,0])+' on '+elements[k,4]+' and lose. Progression '+FormatFloat('0.##',elements[k,2])+' of '+IntToStr(VarArrayHighBound(elements[k,5],1)),0,fName);
       if elements[k,2]=VarArrayHighBound(elements[k,5],1) then begin //here we check if we reach the end of progresion and loose
         if elements[k,12]=1 then begin //here we check the need to restart the system after reach the end of progression and lose
            elements[k,2]:=0; elements[k,0]:=0; //here we reset the cnt_progression, the cnt_sequences
            add_to_file('Spin count - '+IntToStr(spin_count)+'. '+elements[k,13]+'. We have reach the end of progression and lose. The system will restart.',0,fName);
         end else begin //else we stop play this systems
           elements[k,7]:=0;
           add_to_file('Spin count - '+IntToStr(spin_count)+'. '+elements[k,13]+'. We have reach the end of progression and lose. The system is eliminated.',0,fName);
         end;
       end else begin  //else we will check if lost on ZERO
         if last_nr=0 then begin
           add_to_file('Spin count - '+IntToStr(spin_count)+'. '+elements[k,13]+'. We have lost on ZERO. The system will restart.',0,fName);
           elements[k,2]:=0; elements[k,14]:=0; elements[k,0]:=0; //cnt_progression became 0, reset the need to bet, counter is again 0
         end;
       end;
     end;
   end;
 end;
end;

procedure btStartClick(Sender: TObject);
begin
//START CHANGES - all that you may to change - start here

 {Wait for a element not to hit in "X" times, and then bet progression.
0.0 value of 1 unit
0.1 for stop_loss - write 0; for trailing_stop_loss - write 1;
0.2 00-not used
0.3 00-not used
0.4 store last Y landed numbers
0.5 Y
0.6 what to do In case we bet->lose(not on Zero)->wait the next sequence - and during this we have Zero. Reset=1, to ignore=0

x.0 didn_apear - indicate how much times in a row we have the needed sequences
x.1 alert - indicate how much needed sequences we must wait
x.2 cnt_progression - store the current number from progresiion array
x.3 win_coeficient - indicate how much increase the bet on winning
x.4 name - indicate the name of element (look at the s_utils module to get the name, or to add your own names)
x.5 martingale_progression - indicate the element's progression
x.6 cnt_elements - indicate how much same table-elements we have in the group
x.7 play_cnt - indicate how much times the element will play (-1 - the element will always play; 0 - the element will not play; 1 - the element will play only once; 2 - only 2 times; 3 - only 3 times; ...)
x.8 no used
x.9 how much R (or B) must be in one sequence
x.10 system type 1-4
x.11 what colour this system play, X-mean both colours
x.12 restart_after_lost - what to do in case of reach the end of progression and lost - 0=stop the system; 1=restart the system
x.13 system_name
x.14 need to bet
}

 elements:=[
            [0.1,0,00,'00','---------------',15,0],
            [0,8,0,1,'',[0,1,2,4,8,16],1,-1,00,2,3,'R',0,'1.1R',0],
            [0,8,0,1,'',[0,1,2,4,8,16],1,-1,00,2,3,'B',0,'1.1B',0],
           [0,12,0,1,'',[0,1,2,4,8,16],1,-1,00,2,4,'X',0,'1.2X',0,[0,0]],
            [0,8,0,1,'',[0,1,2,4,8,16],1,-1,00,2,1,'R',0,'2.1R',0],
            [0,8,0,1,'',[0,1,2,4,8,16],1,-1,00,2,1,'B',0,'2.1B',0],
            [0,9,0,1,'',[0,1,2,4,8,16],1,-1,00,2,2,'X',0,'2.2X',0,[0,0]],
            [0,9,0,1,'',[0,1,2,4,8,16],1,-1,00,3,3,'R',0,'2.3R',0],
            [0,9,0,1,'',[0,1,2,4,8,16],1,-1,00,3,3,'B',0,'2.3B',0],
            [0,9,0,1,'',[0,1,2,4,8,16],1,-1,00,3,4,'X',0,'2.4X',0,[0,0]],
            [0,6,0,1,'',[0,1,2,4,8,16],1,-1,00,3,1,'R',0,'3.1R',0],
            [0,6,0,1,'',[0,1,2,4,8,16],1,-1,00,3,1,'B',0,'3.1B',0],
            [0,8,0,1,'',[0,1,2,4,8,16],1,-1,00,3,2,'X',0,'3.2X',0,[0,0]],
            [0,6,0,1,'',[0,1,2,4,8,16],1,-1,00,4,3,'R',0,'3.3R',0],
            [0,6,0,1,'',[0,1,2,4,8,16],1,-1,00,4,3,'B',0,'3.3B',0],
            [0,6,0,1,'',[0,1,2,4,8,16],1,-1,00,4,4,'X',0,'3.4X',0,[0,0]],
            [0,5,0,1,'',[0,1,2,4,8,16],1,-1,00,4,1,'R',0,'4.1R',0],
            [0,5,0,1,'',[0,1,2,4,8,16],1,-1,00,4,1,'B',0,'4.1B',0],
            [0,6,0,1,'',[0,1,2,4,8,16],1,-1,00,4,2,'X',0,'4.2X',0,[0,0]],
            [0,6,0,1,'',[0,1,2,4,8,16],1,-1,00,5,3,'R',0,'4.3R',0],
            [0,6,0,1,'',[0,1,2,4,8,16],1,-1,00,5,3,'B',0,'4.3B',0],
            [0,6,0,1,'',[0,1,2,4,8,16],1,-1,00,5,4,'X',0,'4.4X',0,[0,0]],
            [0,3,0,1,'',[0,1,2,4,8,16],1,-1,00,5,1,'R',0,'5.1R',0],
            [0,3,0,1,'',[0,1,2,4,8,16],1,-1,00,5,1,'B',0,'5.1B',0],
            [0,3,0,1,'',[0,1,2,4,8,16],1,-1,00,5,2,'X',0,'5.2X',0,[0,0]],
            [0,4,0,1,'',[0,1,2,4,8,16],1,-1,00,6,3,'R',0,'5.3R',0],
            [0,4,0,1,'',[0,1,2,4,8,16],1,-1,00,6,3,'B',0,'5.3B',0],
            [0,4,0,1,'',[0,1,2,4,8,16],1,-1,00,6,4,'X',0,'5.4X',0,[0,0]],
            [0,3,0,1,'',[0,1,2,4,8,16],1,-1,00,6,1,'R',0,'6.1R',0],
            [0,3,0,1,'',[0,1,2,4,8,16],1,-1,00,6,1,'B',0,'6.1B',0],
            [0,3,0,1,'',[0,1,2,4,8,16],1,-1,00,6,2,'X',0,'6.2X',0,[0,0]],
            [0,4,0,1,'',[0,1,2,4,8,16],1,-1,00,7,3,'R',0,'6.3R',0],
            [0,4,0,1,'',[0,1,2,4,8,16],1,-1,00,7,3,'B',0,'6.3B',0],
            [0,4,0,1,'',[0,1,2,4,8,16],1,-1,00,7,4,'X',0,'6.4X',0,[0,0]]
           ];

 //chips value's
 //chips:=[0,0.01,0.10,1,5,10,25,100];//here you need to specify chip values
 chips:=[0,0.01,0.1,0.5,1,5,10,25,50,100];//here you need to specify chip values

 { initialize files for saving results info
   the file with all info will be c:\2009-07-22_14-37-59_all.txt - the name of file will contain the start date and time
   the file with all landed numbers will be c:\2009-07-22_14-37-59_nr.txt - the name of file will contain the start date and time }
 fName:='c:\';//the files will be saved in directory 'c:\' - you may change this, ex: fName:='c:\Casino\text_results\';

 //initialize file_name with numbers - for sim_mode=2
 fName_numbers:='c:\numbers.txt';//the path with file that contain a list of numbers, ex: 'c:\Casino\my_numbers.txt';
//STOP CHANGES HERE - all changes must do above

 //enter the start_amount
 start_amount:=0;
 InputQuery('Query window','Enter start amount (START BALANCE).',start_amount);
 start_amount:=StrToFloat(start_amount);
 amount:=start_amount;//current amount became start_amount
 if start_amount=0 then Exit;

 //enter how much you want to increase your start_amount
 wish_amount:=start_amount+20;
 InputQuery('Query window','Enter wish amount (END BALANCE).'+#13#10+'Note:'+#13#10+'Start amount = '+FormatFloat('0.##',start_amount),wish_amount);
 wish_amount:=StrToFloat(wish_amount);

 {enter the stop_loss - the script will stop when the balance = stop_loss
  if stop_loss=0 it will not be used, with other words stop_loos will be the end of balance}
 stop_loss := 0; tr_stop_loss:=0;
 if elements[0,1]=1 then begin//if trailing_stop_loss
   InputQuery('Query window','Enter trailing stop loss.'+#13#10+'Note:'+#13#10+'Start amount = '+FormatFloat('0.##',start_amount)+#13#10+'Wish amount = '+FormatFloat('0.##',wish_amount),tr_stop_loss);
   tr_stop_loss:=StrToFloat(tr_stop_loss);
   stop_loss:=amount-tr_stop_loss;//here we set the first stop_loss
 end else begin//if stop_loss
   InputQuery('Query window','Enter stop loss.'+#13#10+'Note:'+#13#10+'Start amount = '+FormatFloat('0.##',start_amount)+#13#10+'Wish amount = '+FormatFloat('0.##',wish_amount),stop_loss);
   stop_loss:=StrToFloat(stop_loss);
 end;

 //option for simulation mode
 sim_mode:=0;
 InputQuery('Query window','Real mode - enter 0.'+#13#10+'Simulation mode - enter 1.'+#13#10+'Read numbers from file - enter 2.'+#13#10+'Use random function - enter 3.',sim_mode);
 sim_mode:=StrToInt(sim_mode);

 yesno:='no';
 InputQuery('Query window','Are you sure to run? yes/no ',yesno);
 if not ((yesno='yes') or (yesno='y')) then exit;

 fName:=fName+FormatDateTime('yyyy-mm-dd_hh-nn-ss',now);
 add_to_file('',-2,fName);
 if (sim_mode=3) then randomize();//here we initialize the random machine

 add_to_file(FormatDateTime('"Script started at" dd.mm.yyyy hh:nn:ss',now),0,fName);
 add_to_file('Start balance $'+FormatFloat('0.##',start_amount)+'. Wishing amount is $'+FormatFloat('0.##',wish_amount)+'. Stop loss is $'+FormatFloat('0.##',stop_loss)+'.',0,fName);

 spin_count:=1; fl_stop:=0; elements_played:=0; was_betting:=0;

while sf(amount)<sf(wish_amount) do begin
  was_betting:=0;

  amount_after_all_bets:=amount; elements_played:=0;
  for k_el:=1 to VarArrayHighBound(elements,1) do begin
    if (elements[k_el,14]=1)and(elements[k_el,7]<>0) then begin //here we check if element didn't apear the wished spins and the play_cnt<>0
      elements[k_el,2]:=elements[k_el,2]+1;//if element didn't apear the wished numbers of spin we increase the cnt_progression
      if elements[k_el,2]=1 then add_to_file('Start betting on '+elements[k_el,13]+'.',0,fName);
      amount_after_all_bets:=amount_after_all_bets-(elements[k_el,5,elements[k_el,2]]*elements[0,0]*elements[k_el,6]);
      if sim_mode=0 then begin //if it is not the simulation mode
        bet_x_on_y(elements[k_el,5,elements[k_el,2]]*elements[0,0],[elements[k_el,4]],chips);//here we bet
        was_betting:=1;
      end;
    end;
    if elements[k_el,7]=0 then elements_played:=elements_played+1;
  end;
  if sf(amount_after_all_bets)<0 then fl_stop:=3; //here we check if the balanca is equal or near 0 (if we have enough balance to bet), in this case the game stops
  if elements_played=(VarArrayHighBound(elements,1)) then fl_stop:=5;

  if was_betting=0 then bet_x_on_y(chips[1],['red','black'],chips);//here we bet on red and black - instead of free spin
  if fl_stop>0 then break;

  case sim_mode of
    2:begin//read numbers from file
        AssignFile(_file,fName_numbers); Reset(_file);//open the file in read mode
        for k_el:=1 to spin_count do
           if not EoF(_file) then last_nr:=ReadLn(_file)//The Readln procedure reads a line of text and then skips to the next line of the file.
                             else fl_stop:=2;
        CloseFile(_file);//close the file
      end;
    3:begin//read numbers from random function
        last_nr:=random(37);
      end;
    else begin//get numbers from the spin
      click_spin_button();
      last_nr:=get_last_landed_number();
    end;
  end;
  if fl_stop>0 then break;

  add_to_file(IntToStr(last_nr),-1, fName);
  stack_array;
  add_to_file('Spin count - '+IntToStr(spin_count)+'. Landed number is '+FormatFloat('00',last_nr)+'-'+landed_is+'. Current amount is $'+FormatFloat('0.##',amount)+'. Lasts='+elements[0,4]+'.',0,fName);
  yesno:=''; for k_el:=1 to VarArrayHighBound(elements,1) do yesno:=yesno+elements[k_el,13]+'='+IntToStr(elements[k_el,0])+', ';
  add_to_file(yesno,0,fName);
  add_to_file('----------------------------------------',0,fName);

  if elements[0,1]=1 then if sf(amount-tr_stop_loss)>sf(stop_loss) then stop_loss:=amount-tr_stop_loss;
  if sf(amount)<=sf(stop_loss) then begin fl_stop:=4; break; end; //here we check if the balanca is equal or near 0 (if we have enough balance to bet), in this case the game stops
  Inc(spin_count);
end;

case fl_stop of
 1: add_to_file('The game stops because we reach the end of progression and lose.',0,fName);
 2: add_to_file('The game stops because we reach the end of file with numbers.',0,fName);
 3: add_to_file('The game stops because the balance is equal or near 0. We do not have enough balance to bet',0,fName);
 4: add_to_file('The game stops because we reach the stop_loss.',0,fName);
 5: add_to_file('The game stops because all elements played their games.',0,fName);
 else add_to_file('Congratulations! The game stops because we reach wishing amount.',0,fName);
end;
add_to_file('Current amount is $'+FormatFloat('0.##',amount)+'. Wishing amount is $'+FormatFloat('0.##',wish_amount)+'. Starting balance is $'+FormatFloat('0.##',start_amount)+'. Stop loss is $'+FormatFloat('0.##',stop_loss)+'.',0,fName);
add_to_file(FormatDateTime('"Script finished at" dd.mm.yyyy hh:nn:ss',now),0,fName); 
end;

procedure btClearMemoClick(Sender: TObject);
begin
  Memo1.Clear();
end;

begin
end;
