uses s_utils;
{Script pug879_MK2} 

var chips, k_el, start_amount, wish_amount, amount, yesno, spin_count, fl_stop, was_betting, sim_mode, stop_loss, tr_stop_loss, amount_after_all_bets;
var elements, last_nr, _file, fName, fName_numbers, k_el2, str_el;

procedure add_to_lastY;
//add last landed number to the set of last Y landed numbers
begin
 if last_nr<>0 then begin
   if number_is(last_nr,'R') then elements[0,4,0]:=copy(elements[0,4,0],2,elements[0,5]-1)+'R'
                             else elements[0,4,0]:=copy(elements[0,4,0],2,elements[0,5]-1)+'B';
   if number_is(last_nr,'L') then elements[0,4,1]:=copy(elements[0,4,1],2,elements[0,5]-1)+'L'
                             else elements[0,4,1]:=copy(elements[0,4,1],2,elements[0,5]-1)+'H';
   if number_is(last_nr,'O') then elements[0,4,2]:=copy(elements[0,4,2],2,elements[0,5]-1)+'O'
                             else elements[0,4,2]:=copy(elements[0,4,2],2,elements[0,5]-1)+'E';
 end else begin
   elements[0,4,0]:=copy(elements[0,4,0],2,elements[0,5]-1)+'0';
   elements[0,4,1]:=copy(elements[0,4,1],2,elements[0,5]-1)+'0';
   elements[0,4,2]:=copy(elements[0,4,2],2,elements[0,5]-1)+'0';
 end;
end;

function landed_is:string
begin
 result:='';
 if last_nr<>0 then begin
   if number_is(last_nr,'R') then result:=result+'R,' else result:=result+'B,';
   if number_is(last_nr,'H') then result:=result+'H,' else result:=result+'L,';
   if number_is(last_nr,'O') then result:=result+'O' else result:=result+'E';
 end else result:='0,0,0';
end;

procedure count_counts(k);
 var str1, str2, k2, k1;
begin
 for k2:=0 to 5 do begin//here we go through the all elements
   str1:=''; for k1:=1 to elements[k,10] do str1:=str1+elements[k,8,k2];//we create the wished sequence
   if elements[k,1]<>-1 then begin//in case we have not the sequence of 11
     str2:=copy(elements[0,4,elements[k,7,k2]],elements[0,5]-elements[k,10]-1,elements[k,10]+2);//get last elements[k,10]+2
     if (copy(str2,1,1)<>elements[k,8,k2]) and (copy(str2,2,elements[k,10])=str1) and (copy(str2,length(str2),1)<>elements[k,8,k2])  //good xRRx
       then elements[k,0,k2]:=elements[k,0,k2]+1; //we increase the count
   end;
 end;
end;

function same_opposite(k):string;
begin
 result:='';
 if elements[k,2]=1 then begin
   if elements[k,9]=0 then result:='(same)'
                      else result:='(opposite)';
 end else begin
   if elements[k,12]=0 then result:='(same)';
   if elements[k,12]=1 then result:='(opposite)';
   if elements[k,12]=2 then result:='(opposite last bet)';
 end;
end;

procedure stack_array;
 var k, str1, str2, k1, k2, sel;
begin
 add_to_lastY;
 for k:=1 to VarArrayHighBound(elements,1) do begin//here we go through the all groups
   count_counts(k);
   if elements[k,14]=1 then begin //we have bet
     k2:=elements[k,13];
     if number_is(last_nr,elements[k,4]) then begin
       amount:=amount+(elements[k,5,elements[k,2]]*elements[0,0]*(elements[k,3]-(elements[k,6]-1)));//in case the win we increase the amount
       add_to_file('Spin count - '+IntToStr(spin_count)+' - '+elements[k,15]+'. We have bet $'+FormatFloat('0.##',elements[k,5,elements[k,2]]*elements[0,0])+' on '+elements[k,4]+same_opposite(k)+' and win. Progression '+FormatFloat('0.##',elements[k,2])+' of '+IntToStr(VarArrayHighBound(elements[k,5],1)),0,fName);
       elements[k,2]:=0; elements[k,4]:=''; elements[k,0,k2]:=0; elements[k,13]:=-1; elements[k,14]:=0; //reset only this EC
     end else begin
       amount:=amount-(elements[k,5,elements[k,2]]*elements[0,0]*elements[k,6]);//in case the lose we decrese amount with how much we have bet
       add_to_file('Spin count - '+IntToStr(spin_count)+' - '+elements[k,15]+'. We have bet $'+FormatFloat('0.##',elements[k,5,elements[k,2]]*elements[0,0])+' on '+elements[k,4]+same_opposite(k)+' and lose. Progression '+FormatFloat('0.##',elements[k,2])+' of '+IntToStr(VarArrayHighBound(elements[k,5],1)),0,fName);
       if elements[k,2]=VarArrayHighBound(elements[k,5],1) then begin //reach the end of progression and lose
          elements[k,2]:=1;//here we reset the cnt_progression
          add_to_file('Spin count - '+IntToStr(spin_count)+' - '+elements[k,15]+'. We have reach the end of progression and lose. The count will restart.',0,fName);
          elements[k,2]:=0; elements[k,4]:=''; elements[k,0,k2]:=0; elements[k,13]:=-1; elements[k,14]:=0; //reset only this EC
       end;
       elements[k,14]:=0;//we pause betting - till meet the new good sequence
     end;
   end;

   if elements[k,14]=0 then begin //if was not bet, or chose another EC after win or lost_end
     if elements[k,13]=-1 then begin //we still wait for some EC, or chose another EC after win or lost_end
       sel:=[0,0,0,0,0,0,[-1,0]];//store current counts from each EC in the group - later we will chose the best one
       for k2:=0 to 5 do begin//here we go through the all elements
         str1:=''; for k1:=1 to elements[k,10] do str1:=str1+elements[k,8,k2];//we create the wished sequence
         if elements[k,1]=-1 then begin//in case we have the sequence of 11 - we need to bet immediately
           str2:=copy(elements[0,4,elements[k,7,k2]],elements[0,5]-elements[k,10],elements[k,10]+1);//get last elements[k,10]+1
           if (copy(str2,2,elements[k,10])=str1) and (copy(str2,1,1)<>elements[k,8,k2])  //good xRR
             then sel[k2]:=1;//we meet the last sequence
         end else begin
           if elements[k,0,k2]>=elements[k,1] then begin
             sel[k2]:=elements[k,0,k2];//store the count
             //if elements[k,0,k2]>elements[k,1] then begin
             str2:=copy(elements[0,4,elements[k,7,k2]],elements[0,5]-elements[k,10],elements[k,10]+1);//get last elements[k,10]+1
             if (copy(str2,2,elements[k,10])=str1) and (copy(str2,1,1)<>elements[k,8,k2])  //good xRR
               then sel[k2]:=sel[k2]+1000;//we meet the last sequence - in case this EC isready to bet - mark it
             //end;
           end;
         end;
       end;
       for k2:=0 to 5 do begin//we select the best EC for play
         if sel[k2]>sel[6,1] then begin sel[6,0]:=k2; sel[6,1]:=sel[k2]; end;
       end;
       if sel[6,0]>-1 then begin
         elements[k,13]:=sel[6,0]; //set what to play
         if (sel[6,1]>1000)or(elements[k,1]=-1) then elements[k,14]:=1;//mean that we need to bet
       end;
     end else begin //mean that we wait for the last sequence before bet
       k2:=elements[k,13];
       str1:=''; for k1:=1 to elements[k,10] do str1:=str1+elements[k,8,k2];//we create the wished sequence
       str2:=copy(elements[0,4,elements[k,7,k2]],elements[0,5]-elements[k,10],elements[k,10]+1);//get last elements[k,10]+1
       if (copy(str2,2,elements[k,10])=str1) and (copy(str2,1,1)<>elements[k,8,k2])  //good xRR
         then elements[k,14]:=1;//we meet the last sequence - next we bet
     end;
   end;
 end;
end;

begin
//START CHANGES - all that you may to change - start here

 {Wait for a element not to hit in "X" times, and then bet progression.
0.0 value of 1 unit
0.1 for stop_loss - write 0; for trailing_stop_loss - write 1;
0.2 not used
0.3 casino name
0.4 store last Y landed numbers
0.5 Y

x.0.y didn_apear - indicate how much times we have the needed sequences
x.1 alert - indicate how much needed sequences we must wait, -1 mean bet immediately after have x.10 R
x.2 cnt_progression - store the current number from progresiion array
x.3 win_coeficient - indicate how much increase the bet on winning
x.4 name - indicate the name of element we will bet on
x.5 martingale_progression - indicate the element's progression
x.6 cnt_elements - indicate how much same table-elements we have in the group
x.7.y what last_Y to use
x.8.y what EC this system play
x.9 first 1 unit bet - to bet the same=0, to bet on the opposite=1
x.10 how much EC must be in one sequence
x.11.y what is the opposite of x.8
x.12 all next progression bets - to bet the same=0; to bet on the opposite=1; to bet on the opposite of what was bet before=2;
x.13 what element we play
x.14 need to bet
x.15 name of group
}

 elements:=[
            [1,0,00,'Roulette Pro - Casino Tropez',['---------------','---------------','---------------'],15],
            [[0,0,0,0,0,0],8,0,1,'',[0,1,2,4,8,16],1,[0,0,1,1,2,2],['R','B','L','H','O','E'],0,2,['B','R','H','L','E','O'],2,-1,0,'gr1'],
            [[0,0,0,0,0,0],6,0,1,'',[0,1,2,4,8,16],1,[0,0,1,1,2,2],['R','B','L','H','O','E'],0,3,['B','R','H','L','E','O'],2,-1,0,'gr2'],
            [[0,0,0,0,0,0],5,0,1,'',[0,1,2,4,8,16],1,[0,0,1,1,2,2],['R','B','L','H','O','E'],0,4,['B','R','H','L','E','O'],2,-1,0,'gr3'],
            [[0,0,0,0,0,0],3,0,1,'',[0,1,2,4,8,16],1,[0,0,1,1,2,2],['R','B','L','H','O','E'],0,5,['B','R','H','L','E','O'],2,-1,0,'gr4'],
            [[0,0,0,0,0,0],3,0,1,'',[0,1,2,4,8,16],1,[0,0,1,1,2,2],['R','B','L','H','O','E'],0,6,['B','R','H','L','E','O'],2,-1,0,'gr5'],
            [[0,0,0,0,0,0],-1,0,1,'',[0,1,2,4,8,16],1,[0,0,1,1,2,2],['R','B','L','H','O','E'],1,11,['B','R','H','L','E','O'],1,-1,0,'gr6']
           ];

 //chips value's
 //chips:=[0,0.01,0.10,1,5,10,25,100];//here you need to specify chip values
 chips:=[0,0.1,0.10,0.50,1,5,10,25];//here you need to specify chip values

 { initialize files for saving results info
   the file with all info will be c:\2009-07-22_14-37-59_all.txt - the name of file will contain the start date and time
   the file with all landed numbers will be c:\2009-07-22_14-37-59_nr.txt - the name of file will contain the start date and time }
 fName:='c:\';//the files will be saved in directory 'c:\' - you may change this, ex: fName:='c:\Casino\text_results\';

 //initialize file_name with numbers - for sim_mode=2
 fName_numbers:='c:\numbers.txt';//the path with file that contain a list of numbers, ex: 'c:\Casino\my_numbers.txt';
//STOP CHANGES HERE - all changes must do above

 //enter the start_amount
 start_amount:=0;
 InputQuery('Query window','Enter start amount (START BALANCE).',start_amount);
 start_amount:=StrToFloat(start_amount);
 amount:=start_amount;//current amount became start_amount
 if start_amount=0 then Exit;

 //enter how much you want to increase your start_amount
 wish_amount:=start_amount+20;
 InputQuery('Query window','Enter wish amount (END BALANCE).'+#13#10+'Note:'+#13#10+'Start amount = '+FormatFloat('0.##',start_amount),wish_amount);
 wish_amount:=StrToFloat(wish_amount);

 {enter the stop_loss - the script will stop when the balance = stop_loss
  if stop_loss=0 it will not be used, with other words stop_loos will be the end of balance}
 stop_loss := 0; tr_stop_loss:=0;
 if elements[0,1]=1 then begin//if trailing_stop_loss
   InputQuery('Query window','Enter trailing stop loss.'+#13#10+'Note:'+#13#10+'Start amount = '+FormatFloat('0.##',start_amount)+#13#10+'Wish amount = '+FormatFloat('0.##',wish_amount),tr_stop_loss);
   tr_stop_loss:=StrToFloat(tr_stop_loss);
   stop_loss:=amount-tr_stop_loss;//here we set the first stop_loss
 end else begin//if stop_loss
   InputQuery('Query window','Enter stop loss.'+#13#10+'Note:'+#13#10+'Start amount = '+FormatFloat('0.##',start_amount)+#13#10+'Wish amount = '+FormatFloat('0.##',wish_amount),stop_loss);
   stop_loss:=StrToFloat(stop_loss);
 end;

 //option for simulation mode
 sim_mode:=0;
 InputQuery('Query window','Real mode - enter 0.'+#13#10+'Simulation mode - enter 1.'+#13#10+'Read numbers from file - enter 2.'+#13#10+'Use random function - enter 3.',sim_mode);
 sim_mode:=StrToInt(sim_mode);

 yesno:='no';
 InputQuery('Query window','Are you sure to run? yes/no ',yesno);
 if not ((yesno='yes') or (yesno='y')) then exit;

 fName:=fName+FormatDateTime('yyyy-mm-dd_hh-nn-ss',now);
 add_to_file('',-2,fName);
 if ((sim_mode=0)or(sim_mode=1)) then set_roulette_window_name(elements[0,3]);
 if (sim_mode=3) then randomize();//here we initialize the random machine

 add_to_file(FormatDateTime('"Script started at" dd.mm.yyyy hh:nn:ss',now),0,fName);
 add_to_file('Start balance $'+FormatFloat('0.##',start_amount)+'. Wishing amount is $'+FormatFloat('0.##',wish_amount)+'. Stop loss is $'+FormatFloat('0.##',stop_loss)+'.',0,fName);

 spin_count:=1; fl_stop:=0; if sim_mode<=1 then clear_table(200,chips); was_betting:=0;

while sf(amount)<sf(wish_amount) do begin
  if (was_betting=1)and(sim_mode=0) then begin ide_delay:=300; clear_table(200,chips); end;
  was_betting:=0;

  amount_after_all_bets:=amount;
  for k_el:=1 to VarArrayHighBound(elements,1) do begin
    if (elements[k_el,14]>0) then begin //here we check what to play
      k_el2:=elements[k_el,13];
      elements[k_el,2]:=elements[k_el,2]+1;//if element didn't apear the wished numbers of spin we increase the cnt_progression
      if elements[k_el,2]=1 then begin //if first 1 unit bet - then chose on what to bet
        if elements[k_el,9]=0 then elements[k_el,4]:=elements[k_el,8,k_el2] else elements[k_el,4]:=elements[k_el,11,k_el2];
      end else begin //if next bets - then chose on what to bet
        if elements[k_el,12]<>0 then begin
          if elements[k_el,12]=2 then begin //if bet on opposite landed
            if (elements[k_el,2] mod 2)=0 then elements[k_el,4]:=elements[k_el,11,k_el2]
                                          else elements[k_el,4]:=elements[k_el,8,k_el2];
          end else elements[k_el,4]:=elements[k_el,11,k_el2]; //if bet on opposite
        end else elements[k_el,4]:=elements[k_el,8,k_el2]; //if bet the same
      end;
      if elements[k_el,2]=1 then add_to_file('Start betting on '+elements[k_el,15]+' - '+elements[k_el,4]+' ('+IntToStr(elements[k_el,10])+' in a row - '+IntToStr(elements[k_el,1])+' times).',0,fName);
      amount_after_all_bets:=amount_after_all_bets-(elements[k_el,5,elements[k_el,2]]*elements[0,0]*elements[k_el,6]);
      if sim_mode=0 then begin //if it is not the simulation mode
        bet_x_on_y(elements[k_el,5,elements[k_el,2]]*elements[0,0],[elements[k_el,4]],chips);//here we bet
        was_betting:=1;
      end;
    end;
  end;
  if sf(amount_after_all_bets)<0 then fl_stop:=3; //here we check if the balanca is equal or near 0 (if we have enough balance to bet), in this case the game stops

  if was_betting=0 then ide_delay:=200;//the speed of free spins. Very small value increase the speed but may pause the script itself, you can try 150
  if fl_stop>0 then break;

  case sim_mode of
    2:begin//read numbers from file
        AssignFile(_file,fName_numbers); Reset(_file);//open the file in read mode
        for k_el:=1 to spin_count do
           if not EoF(_file) then last_nr:=ReadLn(_file)  //The Readln procedure reads a line of text and then skips to the next line of the file.
                             else fl_stop:=2;
        CloseFile(_file);//close the file
      end;
    3:begin//read numbers from random function
        last_nr:=random(37);
      end;
    else begin//get numbers from the spin
      click_spin;
      last_nr:=get_last_number();
    end;
  end;
  if fl_stop>0 then break;

  add_to_file(IntToStr(last_nr),-1, fName);
  stack_array; str_el:='';
  add_to_file('Spin count - '+IntToStr(spin_count)+'. Landed number is '+FormatFloat('00',last_nr)+'-'+landed_is+'. Current amount is $'+FormatFloat('0.##',amount)+'. ',0,fName);
  for k_el:=1 to VarArrayHighBound(elements,1) do begin
    str_el:=str_el+elements[k_el,15]+'-'; for k_el2:=0 to 5 do str_el:=str_el+IntToStr(elements[k_el,0,k_el2])+','; str_el:=str_el+'; ';
  end;
  add_to_file('Spin count - '+IntToStr(spin_count)+'. '+str_el,0,fName);
  add_to_file('------------------------------',0,fName);

  if elements[0,1]=1 then if sf(amount-tr_stop_loss)>sf(stop_loss) then stop_loss:=amount-tr_stop_loss;
  if sf(amount)<=sf(stop_loss) then begin fl_stop:=4; break; end; //here we check if the balanca is equal or near 0 (if we have enough balance to bet), in this case the game stops
  Inc(spin_count);
end;

case fl_stop of
 1: add_to_file('The game stops because we reach the end of progression and lose.',0,fName);
 2: add_to_file('The game stops because we reach the end of file with numbers.',0,fName);
 3: add_to_file('The game stops because the balance is equal or near 0. We do not have enough balance to bet',0,fName);
 4: add_to_file('The game stops because we reach the stop_loss.',0,fName);
 5: add_to_file('The game stops because all elements played their games.',0,fName);
 else add_to_file('Congratulations! The game stops because we reach wishing amount.',0,fName);
end;
add_to_file('Current amount is $'+FormatFloat('0.##',amount)+'. Wishing amount is $'+FormatFloat('0.##',wish_amount)+'. Starting balance is $'+FormatFloat('0.##',start_amount)+'. Stop loss is $'+FormatFloat('0.##',stop_loss)+'.',0,fName);
add_to_file(FormatDateTime('"Script finished at" dd.mm.yyyy hh:nn:ss',now),0,fName);
end;
