{$FORM TForm3, Unit3.sfm}

uses
  Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, 
  StdCtrls, Menus;

var x:TForm;
{File Variables}
var F : Text;
    S : String;  
var i,n;

{#### Window Operations ##############################################}
procedure load_winpos;
begin
    AssignFile(F,'c:\rss-data\set_winpos');{If no file exist. Then you will get an error message}
    Reset(F);{open the file for reading}
    i := 0;
    while not eof(F) do {loop that will repeat until the end of file will be not found}
    begin
        S:=ReadLn(F); {read the first line into "s" variable}
        if i=0 then Self.Top:=s;
        if i=1 then Self.Left:=s;
		if i=2 then Color:=s;
		if i=3 then ListBox_EC.Color:=s;
		if i=4 then ListBox_EC_OnOff.Color:=s;
		if i=5 then ListBox_EC_Unit.Color:=s;
		if i=6 then ListBox_EC_Alert.Color:=s;
		if i=7 then ListBox_EC.Font.Color:=s;
		if i=8 then ListBox_EC_OnOff.Font.Color:=s;
		if i=9 then ListBox_EC_Unit.Font.Color:=s;
		if i=10 then ListBox_EC_Alert.Font.Color:=s;
		Inc(i);
        //i := i+1;
    end;
    Self.ClientHeight:=280;
    CloseFile(F);//close the file
end;

procedure close_me;
begin             
    if ListBox_EC.ItemIndex=-1 then ListBox_EC.ItemIndex:=1;
    if ListBox_EC_OnOff.ItemIndex=-1 then ListBox_EC.ItemIndex:=1;
    if ListBox_EC_Alert.ItemIndex=-1 then ListBox_EC.ItemIndex:=1;
    if ListBox_EC_Unit.ItemIndex=-1 then ListBox_EC.ItemIndex:=1;
	
    AssignFile(F,'c:\rss-data\set_winpos');
    Rewrite(F);              
    Writeln(F,x.Top); {0}
    Writeln(F,x.Left); {1}
	Writeln(F,Color); {2}
	Writeln(F,ListBox_EC.Color); {3}
	Writeln(F,ListBox_EC_OnOff.Color); {4}
	Writeln(F,ListBox_EC_Unit.Color); {5}
	Writeln(F,ListBox_EC_Alert.Color); {6}
	Writeln(F,ListBox_EC.Font.Color); {7}
	Writeln(F,ListBox_EC_OnOff.Font.Color); {8}
	Writeln(F,ListBox_EC_Unit.Font.Color); {9}
	Writeln(F,ListBox_EC_Alert.Font.Color); {10}
    CloseFile(F); 
end;                         
{#### End: Window Operations #########################################}

procedure index_list(arg1);
begin
    ListBox_EC.ItemIndex:=arg1;
    ListBox_EC.ItemIndex:=arg1;
    ListBox_EC_OnOff.ItemIndex:=arg1;
    ListBox_EC_Alert.ItemIndex:=arg1;
    ListBox_EC_Unit.ItemIndex:=arg1;
    
    Edit_On.Text:=ListBox_EC_OnOff.Items.Strings[arg1];
    Edit_Alert.Text:=ListBox_EC_Alert.Items.Strings[arg1]; 
    Edit_Unit.Text:=ListBox_EC_Unit.Items.Strings[arg1];  
end;

procedure enable_menu(arg1);{Turn objects on or of}
begin
MainMenu1_LoadSet4ListBox_EC.Enabled:=arg1;
MainMenu1_SaveSet4ListBox_EC.Enabled:=arg1;
MainMenu1_LoadSet4ListBox_EC_Alert.Enabled:=arg1;
MainMenu1_SaveSet4ListBox_EC_Alert.Enabled:=arg1;
MainMenu1_LoadSet4ListBox_EC_OnOff.Enabled:=arg1;
MainMenu1_SaveSet4ListBox_EC_OnOff.Enabled:=arg1;
MainMenu1_LoadSet4ListBox_EC_Unit.Enabled:=arg1;
MainMenu1_SaveSet4ListBox_EC_Unit.Enabled:=arg1;
end;

procedure load_settings(FileName);
begin
	OpenDialog1.Title:='Open File: Open Element/System settings.';
	OpenDialog1.InitialDir:='C:\Users\ThomasGrant\Desktop\Casino\Software\RSS&RSS_Pro\RSS_Pro\RSS_Pro_Scripts\RSS_Pro_for_BV\RSS_Pro_BV_Bot_V1\Settings';
	OpenDialog1.DefaultExt:='.txt';
	OpenDialog1.FileName:=FileName; {'elements_systems_settings_ListBox_EC';}
	OpenDialog1.Filter:='Txt files (*.txt)|*.txt';
	if OpenDialog1.FileName='' then 
    begin
        ShowMessage('Open file was cancelled');{If you press cancel, this message will appear}
    end;
end;

procedure save_settings(FileName);
begin
	SaveDialog1.Title:='Save File: Open Element/System settings.';
	SaveDialog1.InitialDir:='C:\Users\ThomasGrant\Desktop\Casino\Software\RSS&RSS_Pro\RSS_Pro\RSS_Pro_Scripts\RSS_Pro_for_BV\RSS_Pro_BV_Bot_V1\Settings';
	SaveDialog1.DefaultExt:='.txt';
	SaveDialog1.FileName:=FileName; {'elements_systems_settings_ListBox_EC';}
	SaveDialog1.Filter:='Txt files (*.txt)|*.txt';
	if SaveDialog1.FileName='' then 
    begin
        ShowMessage('Save file was cancelled');{If you press cancel, this message will appear}
    end;
end;

{#### Main Form Procedures ###########################################}
procedure Form3Create(Sender: TObject);
begin
    load_winpos;
    enable_menu(0);
    MainMenu1_SaveSet4ListBox_EC.Enabled:=1;
	MainMenu1_LoadSet4ListBox_EC_OnOff.Enabled:=1;
	MainMenu1_LoadSet4ListBox_EC_Alert.Enabled:=1;
end;

procedure Form3Close(Sender: TObject; var Action: TCloseAction);
begin
    x:=Sender;
    close_me;                               
end;
{#### End: Main Form Procedures ######################################}

{#### ListBox Procedures #############################################}
procedure ListBox_ECClick(Sender: TObject);
begin
    index_list(ListBox_EC.ItemIndex);
end;

procedure ListBox_EC_OnOffClick(Sender: TObject);
begin
    index_list(ListBox_EC_OnOff.ItemIndex);
end;

procedure ListBox_EC_AlertClick(Sender: TObject);
begin
    index_list(ListBox_EC_Alert.ItemIndex);
end;

procedure ListBox_EC_UnitClick(Sender: TObject);
begin     
    index_list(ListBox_EC_Unit.ItemIndex);
end;
{#### End: ListBox Procedures ########################################}

{#### Edit Main Fields Procedures ####################################}
procedure Edit_OnKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
		ListBox_EC_OnOff.Items.Strings[ListBox_EC_OnOff.ItemIndex]:=Edit_On.Text;
    end;    
end;

procedure Edit_AlertKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
		ListBox_EC_Alert.Items.Strings[ListBox_EC_Alert.ItemIndex]:=Edit_Alert.Text;
    end;    
end;

procedure Edit_UnitKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #13 then
    begin           
        Key := #0;
		ListBox_EC_Unit.Items.Strings[ListBox_EC_Unit.ItemIndex]:=Edit_Unit.Text;
    end;    
end;
{#### End: Edit Main Fields Procedures ###############################}

{#### Menu Procedures ################################################}
procedure MainMenu1_LoadSet4ListBox_ECClick(Sender: TObject);
begin
	load_settings('elements_systems_settings_ListBox_EC');
	if OpenDialog1.FileName=<>'' then
	begin         
        ListBox_EC.Clear();   
        ListBox_EC.Items.LoadFromFile(OpenDialog1.FileName);
    end;
    enable_menu(0);
    MainMenu1_LoadSet4ListBox_EC_Alert.Enabled:=1;
end;

procedure MainMenu1_SaveSet4ListBox_ECClick(Sender: TObject);
begin
	save_settings('elements_systems_settings_ListBox_EC');
	if OpenDialog1.FileName=<>'' then
	begin
        ListBox_EC.Items.SaveToFile(SaveDialog1.FileName);
    end;
    enable_menu(0);
    MainMenu1_SaveSet4ListBox_EC_Alert.Enabled:=1;
end;

procedure MainMenu1_LoadSet4ListBox_EC_AlertClick(Sender: TObject);
begin
	load_settings('elements_systems_settings_ListBox_EC_Alert');
	if OpenDialog1.FileName=<>'' then
	begin         
        ListBox_EC_Alert.Clear();  
        ListBox_EC_Alert.Items.LoadFromFile(OpenDialog1.FileName)
    end;
    enable_menu(0);
    MainMenu1_LoadSet4ListBox_EC_OnOff.Enabled:=1;
end;

procedure MainMenu1_SaveSet4ListBox_EC_AlertClick(Sender: TObject);
begin
	save_settings('elements_systems_settings_ListBox_EC_Alert');
	if OpenDialog1.FileName=<>'' then
	begin
        ListBox_EC.Items.SaveToFile(SaveDialog1.FileName);
    end;
    enable_menu(0);
    MainMenu1_SaveSet4ListBox_EC_Alert.Enabled:=1;
end;

procedure MainMenu1_LoadSet4ListBox_EC_OnOffClick(Sender: TObject);
begin
	load_settings('elements_systems_settings_ListBox_EC_OnOff');
	if OpenDialog1.FileName=<>'' then
	begin         
        ListBox_EC_OnOff.Clear();  
        ListBox_EC_OnOff.Items.LoadFromFile(OpenDialog1.FileName)
    end;
    enable_menu(0);
    MainMenu1_LoadSet4ListBox_EC_Unit.Enabled:=1;
end;

procedure MainMenu1_SaveSet4ListBox_EC_OnOffClick(Sender: TObject);
begin
	save_settings('elements_systems_settings_ListBox_EC_OnOff');
	if OpenDialog1.FileName=<>'' then
	begin
        ListBox_EC.Items.SaveToFile(SaveDialog1.FileName);
    end;
    enable_menu(0);
    MainMenu1_SaveSet4ListBox_EC_Alert.Enabled:=1;
end;

procedure MainMenu1_LoadSet4ListBox_EC_UnitClick(Sender: TObject);
begin
	load_settings('elements_systems_settings_ListBox_EC_Unit');
	if OpenDialog1.FileName=<>'' then
	begin         
        ListBox_EC_Unit.Clear();  
        ListBox_EC_Unit.Items.LoadFromFile(OpenDialog1.FileName)
    end;
    enable_menu(0);
    MainMenu1_SaveSet4ListBox_EC.Enabled:=1;
end;

procedure MainMenu1_SaveSet4ListBox_EC_UnitClick(Sender: TObject);
begin
	save_settings('elements_systems_settings_ListBox_EC_Unit');
	if OpenDialog1.FileName=<>'' then
	begin
        ListBox_EC.Items.SaveToFile(SaveDialog1.FileName);
    end;
    enable_menu(0);
    MainMenu1_SaveSet4ListBox_EC_Alert.Enabled:=1;
end;

procedure MainMenu1_Form_BG_ColorClick(Sender: TObject);
begin
    ColorDialog1.Execute(false);
    Color:=ColorDialog1.Color;
end;

procedure MainMenu1_ListBox_EC_BG_ColorClick(Sender: TObject);
begin
    ColorDialog1.Execute(false);
    ListBox_EC.Color:=ColorDialog1.Color;
end;

procedure MainMenu1_ListBox_EC_OnOff_BG_ColorClick(Sender: TObject);
begin
    ColorDialog1.Execute(false);
    ListBox_EC_OnOff.Color:=ColorDialog1.Color;
end;

procedure MainMenu1_ListBox_EC_Unit_BG_ColorClick(Sender: TObject);
begin
    ColorDialog1.Execute(false);
    ListBox_EC_Unit.Color:=ColorDialog1.Color;
end;

procedure MainMenu1_ListBox_EC_Alert_BG_ColorClick(Sender: TObject);
begin
    ColorDialog1.Execute(false);
    ListBox_EC_Alert.Color:=ColorDialog1.Color;
end;

procedure MainMenu1_ListBox_EC_Font_ColorClick(Sender: TObject);
begin
    FontDialog1.Execute(false);
    ListBox_EC.Font.Color:=FontDialog1.Font.Color;
end;

procedure MainMenu1_ListBox_EC_OnOff_Font_ColorClick(Sender: TObject);
begin
    FontDialog1.Execute(false);
    ListBox_EC_OnOff.Font.Color:=FontDialog1.Font.Color;
end;

procedure MainMenu1_ListBox_EC_Unit_Font_ColorClick(Sender: TObject);
begin
    FontDialog1.Execute(false);
    ListBox_EC_Unit.Font.Color:=FontDialog1.Font.Color;
end;

procedure MainMenu1_ListBox_EC_Alert_Font_ColorClick(Sender: TObject);
begin
    FontDialog1.Execute(false);
    ListBox_EC_Alert.Font.Color:=FontDialog1.Font.Color;
end;
{#### End: Menu Procedures ###########################################}

begin
end;
